# BSP для платы OrangePi PC на базе Allwinner H3 (ARMv7 Cortex-A7 QuadCore)

## Сведения об устройстве

Платформа OrangePi является участником [академической программы](https://www.kpda.ru/education/akademicheskaya-programma/), поскольку по многим параметрам весьма удобна для обучения молодых специалистов основам системной разработки. BSP преднамеренно выполнен минималистичным, чтобы предоставить возможность самостоятельной разработки разнопланового системного и драйверного программного обеспечения.

Спецификации OrangePi PC доступны на [официальном сайте производителя](http://www.orangepi.org/html/hardWare/computerAndMicrocontrollers/details/Orange-Pi-PC.html)

Форм-фактор устройства:

![OrangePi PC](https://habrastorage.org/webt/zd/8z/9f/zd8z9fynmiwh6ylucayjr8w_ssk.jpeg)

## Руководство пользователя и бинарная сборка

- [Бинарный релиз](https://git.kpda.ru/BSP/kpda-bsp-allwinner-h3-orangepipc/releases/tag/release-2021-v2)
- [Руководство пользователя](https://git.kpda.ru/BSP/kpda-bsp-allwinner-h3-orangepipc/releases/download/release-2021-v2/UserManual.pdf)

## Поддерживаемые редакции Нейтрино

- 2021
- 2020 (ограниченно)

## Сборка BSP

Скопировать BSP в рабочую директорию

Сменить текущую директорию на директорию с BSP

`cd kpda-bsp-allwinner-h3-orangepipc`

Для сборки образа из файла построения orangepi.build

`make -j$(nproc)`

## Передача образа на плату
- скопировать полученный образ в папку tftp-сервера;

`tftp -R 6969:6969 172.16.x.x -c put ifs-h3-orangepi.bin ifs-h3-orangepi.bin`

- подключить плату по usb-uart;
- проверить наличие устройства /dev/ttyUSB0;
- настроить minicom со следующими параметрами: скорость 115200, 8 бит, без контроля
четности, 1 стоп-бит, порт /dev/ttyUSB0;
- запустить minicom и включить плату;
- после запуска U-Boot ввести следующую последовательность команд:


Установка ip-адреса для модуля:

`=> setenv ipaddr 172.16.x.x`

Установка ip-адреса для tftp-сервера:

`=> setenv serverip 172.16.x.x`

`=> setenv gatewayip 172.16.x.x`

Загрузка

```
=> tftpboot 0x41000000 ifs-h3-orangepi.bin
=> go 0x41000000
```

Пример скрипта `tftp.sh` для автоматизации:

```
#!/bin/bash

set -ex

TFTP_SERIAL=${TTY_SERIAL:-/dev/ttyUSB0}
TFTP_CLIENT=172.16.x.x
TFTP_SERVER=172.16.x.x

image="ifs-h3-orangepi.bin"

tftp -R 6969:6969 $TFTP_SERVER -c put $image $image
echo "setenv ipaddr $TFTP_CLIENT" > $TFTP_SERIAL
echo "setenv serverip $TFTP_SERVER" > $TFTP_SERIAL
echo "setenv gatewayip $TFTP_SERVER" > $TFTP_SERIAL
echo "tftpboot 0x41000000 $image; go 0x41000000" > $TFTP_SERIAL
```

Запуск:

`./tftp.sh`

## Поддерживаемые компоненты
|    Компонент   |   Поддержка   | Протестировано | Комментарий                                            |
| :------------: |   :-------:   | :------------: | :----------------------------------------------------: |
|       RAM      |      1GB      |       +        |                                                        |
|       SMP      |   4 CPU cores |       +        |                                                        |
|      UART      |       +       |       +        |                                                        |
|       USB      |       +       |       +        |                                                        |
|       NET      |       +       |       +        |                                                        |
|       SD       |       +       |       +        | Версия исходного кода драйвера - 57d005663e            |
|       MMC      |       +       |       +        | Версия исходного кода драйвера - 57d005663e            |
