/*
 * (c) 2023, SWD Embedded Systems Limited, http://www.kpda.ru
 */

/*
 * Allwiner H3 SpinLock support
 */

#include "startup.h"
#include <arm/aw_h3.h>

void 
aw_h3_spinlock_init(void) 
{
	uint32_t val1 = in32(AW_H3_CCU_BASE + BUS_CLK_GATING_REG1);
	out32(AW_H3_CCU_BASE + BUS_CLK_GATING_REG1, 
			val1 | CCU_BUS_CLK_GATING1_SPINLOCK);


	uint32_t val2 = in32(AW_H3_CCU_BASE + BUS_SOFT_RST_REG1);
	out32(AW_H3_CCU_BASE + BUS_SOFT_RST_REG1, 
			val2 | CCU_BUS_SOFT_RESET1_SPINLOCK);		
}

uint32_t 
aw_h3_spinlock_check(uint32_t lock) 
{
	return (in32(AW_H3_SPINLOCK_BASE + SPINLOCK_STATUS_REG) & (1U << lock));
}

void 
aw_h3_spinlock_lock(uint32_t lock) 
{
	for (;;) {
		if (in32(AW_H3_SPINLOCK_BASE + SPINLOCK_LOCK_REGN((unsigned) lock)) == 0) {
			break;
		}
	}
}

void 
aw_h3_spinlock_unlock(uint32_t lock) 
{
	out32(AW_H3_SPINLOCK_BASE + SPINLOCK_LOCK_REGN((unsigned) lock), 0);
}