/*
 * (c) 2023, SWD Embedded Systems Limited, http://www.kpda.ru
 */

/*
 * Allwinner H3 Timer support
 */

#include "startup.h"
#include <arm/aw_h3.h>

void
aw_h3_timer_init(void) 
{
	uint32_t val1 = in32(AW_H3_CCU_BASE + AVS_CLK_REG);
	out32(AW_H3_CCU_BASE + AVS_CLK_REG, val1 | CCU_THS_CLK_SCLK_GATING);

	out32(AW_H3_TIMER_BASE + AVS_CNT_CTL_REG, AVS_CNT1_EN |AVS_CNT0_EN);

	out32(AW_H3_TIMER_BASE + AVS_CNT_DIV_REG, 
			(TIMER_INT_VAL_1MKS << AVS_CNT1_D_SHIFT) | TIMER_INT_VAL_1MS);

	out32(AW_H3_TIMER_BASE + AVS_CNT0_REG, 0);	
	out32(AW_H3_TIMER_BASE + AVS_CNT1_REG, 0);			
}

void 
mdelay(uint32_t ms) 
{
	uint32_t t1, t2;

	t1 = in32(AW_H3_TIMER_BASE + AVS_CNT0_REG);
	t2 = t1 + ms;
	do {
		t1 = in32(AW_H3_TIMER_BASE + AVS_CNT0_REG);
	} while (t2 >= t1);

	return;
}

void 
udelay(uint32_t us) 
{
	uint32_t t1, t2;

	t1 = in32(AW_H3_TIMER_BASE + AVS_CNT1_REG);
	t2 = t1 + us;
	do {
		t1 = in32(AW_H3_TIMER_BASE + AVS_CNT1_REG);
	} while (t2 >= t1);

	return;
}
