/*
 * (c) 2023, SWD Embedded Systems Limited, http://www.kpda.ru
 */

/*
 * Add Allwinner H3 to the hardware info section of the syspage.
 */

#include "startup.h"
#include "hwinfo_private.h"
#include <drvr/hwinfo.h>                // for hwi support routines in libdrvr
#include <arm/aw_h3.h>

void
init_hwinfo()
{
    unsigned hwi_bus_internal = 0;

	/* add  UART */
	{
		unsigned hwi_off;
		hwiattr_uart_t attr = HWIATTR_UART_T_INITIALIZER;
		struct hwi_inputclk clksrc = {.clk = 24000000, .div = 16};
		HWIATTR_UART_SET_NUM_IRQ(&attr, 1);
		HWIATTR_UART_SET_NUM_CLK(&attr, 1);

		/* create uart0 */
		HWIATTR_UART_SET_LOCATION(&attr, AW_H3_UART0_BASE, AW_H3_UART_SIZE, 0, hwi_find_as(AW_H3_UART0_BASE, 1));
		hwi_off = hwidev_add_uart("uart", &attr, hwi_bus_internal);
		ASSERT(hwi_find_unit(hwi_off) == 0);
		hwitag_set_ivec(hwi_off, 0, AW_H3_UART0_IRQ);
		hwitag_set_inputclk(hwi_off, 0, &clksrc);

		/* historically the UART's were called 'omap' so add these synonyms */
		hwi_add_synonym(hwi_find_device("uart", 0), "seromap");
	}
}
