/*
 * (c) 2023, SWD Embedded Systems Limited, http://www.kpda.ru
 */

/*
 * Allwinner H3 system timer support.
 * Used generic ARMv7 Global Timer
 */

#include "startup.h"

extern unsigned armv7gt_cntfrq;

/*
 * The CNTFRQ is a Generic Timer register, it indicates the system counter clock frequency in Hz.
 */
static unsigned 
timer_read_cntfrq_v7gt()
{
	unsigned frq;

	__asm__ __volatile__("mrc p15, 0, %0, c14, c0, 0" : "=r" (frq));
	return frq;
}

void
init_qtime()
{   
    kprintf("Initializing Timer...\n");

    armv7gt_cntfrq = timer_read_cntfrq_v7gt();

    init_qtime_v7gt();
}
