#
# (c) 2010-2019, SWD Embedded Systems Limited, http://www.kpda.ru
#

ifndef QCONFIG
QCONFIG=qconfig.mk
endif
include $(QCONFIG)

define PINFO
PINFO DESCRIPTION=startup library
endef

ASMOFF_FORMAT_x86 = cpp

NAME = startup

DEFFILE = asmoff.def 

INSTALLDIR = usr/lib

MDRIVER_SRCPATH = $(MDRIVER_ROOT)/$(CPU) $(MDRIVER_ROOT)
EXTRA_SRCVPATH += $(if $(wildcard $(MDRIVER_ROOT)/mdriver.c),$(MDRIVER_SRCPATH))
EXTRA_INCVPATH +=  $(PROJECT_ROOT)/private/$(CPU)

# Temporary exclude SSP (will use native libc's support instead).
EXCLUDE_OBJS += ssp.o _init_ssp.o
# Exclude elf64.c for x86
EXCLUDE_OBJS += elf64.o
# Include elf64.c for e2k
EXTRA_OBJS_e2k = elf64.o 
EXTRA_OBJS += $(EXTRA_OBJS_$(CPU))

-include extra.mk
-include ../../roots.mk
ifndef MDRIVER_ROOT
MDRIVER_ROOT=$(PRODUCT_ROOT)/mdriver
endif

VEND_qss=extra
VENDOR=$(VEND_$(firstword $(BUILDENV) qss))

PRE_SRCVPATH = $(if $(wildcard $(PROJECT_ROOT)/$(VENDOR)),$(PROJECT_ROOT)/$(VENDOR)/$(CPU) $(PROJECT_ROOT)/$(VENDOR))


#####AUTO-GENERATED by packaging script... do not checkin#####
#   INSTALL_ROOT_nto = $(PROJECT_ROOT)/../../../../install
#   USE_INSTALL_ROOT=1
##############################################################

include $(MKFILES_ROOT)/qtargets.mk


asmoff.def: $(PROJECT_ROOT)/asmoff.h $(CPU_ROOT)/asmoff.c

CCVFLAG_64 = -D_PADDR_BITS=64

CCFLAGS_gcc_ = -O2 -fomit-frame-pointer -fno-PIE -fno-delete-null-pointer-checks -Wall -Wextra
CCFLAGS_gcc_qcc = $(CCFLAGS_gcc_)
CCFLAGS_lcc_ = -O2 -fno-PIE -Wall -Wextra -Wno-main -Wno-builtin-functions-redefined
CCFLAGS_lcc_qcc = $(CCFLAGS_lcc_)
CCFLAGS_$(BUILDENV) = -DBUILDENV_$(BUILDENV)
CCFLAGS += $(CCFLAGS_$(COMPILER_TYPE)_$(COMPILER_DRIVER)) $(CCFLAGS_$(BUILDENV))

#
# Allow us to generate the deprecated sections
#
CCFLAGS += -DENABLE_DEPRECATED_SYSPAGE_SECTIONS

#
# Enable available compression algorithms
#
CCFLAGS += $(if $(wildcard $(addsuffix /libucl.a,$(LIBVPATH))),-DSUPPORT_CMP_UCL)
#CCFLAGS += $(if $(wildcard $(addsuffix /liblzo.a,$(LIBVPATH))),-DSUPPORT_CMP_LZO)
CCFLAGS += $(if $(wildcard $(addsuffix /liblz4-dec.a,$(LIBVPATH))),-DSUPPORT_CMP_LZ4)
CCFLAGS += $(if $(wildcard $(addsuffix /libzstd-dec.a,$(LIBVPATH))),-DSUPPORT_CMP_ZSTD)

CCFLAGS_e2k += -fkernel

#
# This particular little kludge is to stop GCC from using F.P. instructions
# to move 8 byte quantities around. 
#
ifeq ($(BUILDENV),qss)
CC_nto_ppc_gcc += -mno-fp-moves
CC_nto_ppc_gcc_qcc += -Wc,-mno-fp-moves
else
CC_nto_ppc_gcc += -msoft-float
CC_nto_ppc_gcc_qcc += -Wc,-msoft-float
endif
CCFLAGS_arm += -marm
CCFLAGS += $(CCFLAGS_$(CPU))

callout_interrupt_mips_smp.o: callout_interrupt_mips_smp.S callout_interrupt_mips.S
callout_interrupt_85xxcpm.o: callout_interrupt_85xxcpm.s callout_interrupt_8260.s

print_sysp.o: print_sysp.c $(CPU_ROOT)/cpu_print_sysp.ci

# Prevent building with debug for the standard build.
# Temporary until linker has been changed.
CCOPTS:=$(filter-out -g,$(CCOPTS))
