/*
 * (c) 2021, SWD Embedded Systems Limited, http://www.kpda.ru
 */

#include "startup.h"

void
hwitag_add_hypervisor(char *name)
{
#if defined(HWI_TAG_NAME_hypervisor)
	int cnt;
	hwi_tag *tag;

	tag = hwi_alloc_tag(HWI_TAG_INFO(hypervisor));
	memcpy(tag->hypervisor.name, name, 12);
	tag->hypervisor.name[12] = 0;

	struct _hypervisor_vendors {
			char id[12];
			uint32_t flags;
	} hypervisor_vendors[] = {
		{
			"VMwareVMware",
			hwi_hypervisor_VMWARE
		},
		{
			"KVMKVMKVM\0\0\0",
			hwi_hypervisor_KVM
		},
		{
			"TCGTCGTCGTCG",
			hwi_hypervisor_QEMU
		},
		{
			"Microsoft Hv",
			hwi_hypervisor_HV
		},
		{
			"XenVMMXenVMM",
			hwi_hypervisor_XEN
		},
		{
			{ 0 },
			0
		}
	};

	for (cnt = 0; (hypervisor_vendors[cnt].flags & hwi_hypervisor_MASK); ++cnt)
	{
		if (!memcmp(tag->hypervisor.name, hypervisor_vendors[cnt].id, 12))
		{
			tag->hypervisor.flags |= hypervisor_vendors[cnt].flags;
			break;
		}
	}
#endif
}
